symfony/src/Entity/Ad.php
<?php

namespace App\Entity;

use App\Entity\User;
use Cocur\Slugify\Slugify;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;

/**
 * @ORM\Entity(repositoryClass="App\Repository\AdRepository")
 * @ORM\HasLifecycleCallbacks
 * @UniqueEntity(
 *  fields={"title"},
 *  message="Une autre annonce possède déjà ce titre, merci de le modifier"
 * )
 */
class Ad
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Length(min=10, max=255, minMessage="Le titre doit faire plus de 10 caractères !", maxMessage="Le titre ne peut pas faire plus de 255 caractères")
     */
    private $title;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $slug;

    /**
     * @ORM\Column(type="float")
     */
    private $price;

    /**
     * @ORM\Column(type="text")
     * @Assert\Length(min=20, minMessage="Votre introduction doit faire plus de 20 caractères")
     */
    private $introduction;

    /**
     * @ORM\Column(type="text")
     * @Assert\Length(min=100, minMessage="Votre description ne peut pas faire moins de 100 caractères")
     */
    private $content;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Url()
     */
    private $coverImage;
    /**
     * @ORM\Column(type="integer")
     */
    private $rooms;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Image", mappedBy="ad", orphanRemoval=true, cascade={"persist"})
     * @Assert\Valid()
     */
    private $images;

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\User", inversedBy="ads")
     * @ORM\JoinColumn(nullable=false)
     */
    private $author;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Booking", mappedBy="ad")
     */
    private $bookings;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Comment", mappedBy="ad", orphanRemoval=true)
     */
    private $comments;

    /**
     * @ORM\OneToOne(targetEntity="App\Entity\AnnounceAddress", orphanRemoval=true, cascade={"persist"}))
     */
    private $address;

    public function __construct()
    {
        $this->images = new ArrayCollection();
        $this->bookings = new ArrayCollection();
        $this->comments = new ArrayCollection();
        $this->address = new AnnounceAddress("","",null);
    }
    /**
     * Permet d'initialiser le slug !
     *
     * @ORM\PrePersist
     * @ORM\PreUpdate
     * 
     * @return void
     */
    public function initializeSlug() {
        if(empty($this->slug)) {
            $slugify = new Slugify();
            $this->slug = $slugify->slugify($this->title);
        }
    }
    /**
     * Permet de récupérer le commentaire d'un auteur par rapport à une annonce
     *
     * @param User $author
     * @return Comment|null
     */
    public function getCommentFromAuthor(User $author){
        foreach($this->comments as $comment) {
            if($comment->getAuthor() === $author) return $comment;
        }
        return null;
    }
    /**
     * Permet d'obtenir la moyenne globale des notes pour cette annonce
     *
     * @return float
     */
    public function getAvgRatings() {
        // Calculer la somme des notations
        $sum = array_reduce($this->comments->toArray(), function($total, $comment) {
            return $total + $comment->getRating();
        }, 0);
        // Faire la division pour avoir la moyenne
        if(count($this->comments) > 0) return $sum / count($this->comments);
        return 0;
    }
    /**
     * Permet d'obtenir un tableau des jours qui ne sont pas disponibles pour cette annonce
     *
     * @return array Un tableau d'objets DateTime représentant les jours d'occupation
     */
    public function getNotAvailableDays() {
        $notAvailableDays = [];
        foreach($this->bookings as $booking) {
            // Calculer les jours qui se trouvent entre la date d'arrivée et de départ
            $resultat = range(
                $booking->getStartDate()->getTimestamp(), 
                $booking->getEndDate()->getTimestamp(), 
                24 * 60 * 60
            );
            
            $days = array_map(function($dayTimestamp){
                return new \DateTime(date('Y-m-d', $dayTimestamp));
            }, $resultat);
            $notAvailableDays = array_merge($notAvailableDays, $days);
        }
        return $notAvailableDays;
    }
    public function getId()
    {
        return $this->id;
    }
    public function getTitle(): ?string
    {
        return $this->title;
    }
    public function setTitle(string $title): self
    {
        $this->title = $title;
        return $this;
    }
    public function getSlug(): ?string
    {
        return $this->slug;
    }
    public function setSlug(string $slug): self
    {
        $this->slug = $slug;
        return $this;
    }
    public function getPrice(): ?float
    {
        return $this->price;
    }
    public function setPrice(float $price): self
    {
        $this->price = $price;
        return $this;
    }
    public function getIntroduction(): ?string
    {
        return $this->introduction;
    }
    public function setIntroduction(string $introduction): self
    {
        $this->introduction = $introduction;
        return $this;
    }
    public function getContent(): ?string
    {
        return $this->content;
    }
    public function setContent(string $content): self
    {
        $this->content = $content;
        return $this;
    }
    public function getCoverImage(): ?string
    {
        return $this->coverImage;
    }
    public function setCoverImage(string $coverImage): self
    {
        $this->coverImage = $coverImage;
        return $this;
    }
    public function getRooms(): ?int
    {
        return $this->rooms;
    }
    public function setRooms(int $rooms): self
    {
        $this->rooms = $rooms;
        return $this;
    }
    /**
     * @return Collection|Image[]
     */
    public function getImages(): Collection
    {
        return $this->images;
    }
    public function addImage(Image $image): self
    {
        if (!$this->images->contains($image)) {
            $this->images[] = $image;
            $image->setAd($this);
        }
        return $this;
    }
    public function removeImage(Image $image): self
    {
        if ($this->images->contains($image)) {
            $this->images->removeElement($image);
            // set the owning side to null (unless already changed)
            if ($image->getAd() === $this) {
                $image->setAd(null);
            }
        }
        return $this;
    }
    public function getAuthor(): ?User
    {
        return $this->author;
    }
    public function setAuthor(?User $author): self
    {
        $this->author = $author;
        return $this;
    }
    /**
     * @return Collection|Booking[]
     */
    public function getBookings(): Collection
    {
        return $this->bookings;
    }
    public function addBooking(Booking $booking): self
    {
        if (!$this->bookings->contains($booking)) {
            $this->bookings[] = $booking;
            $booking->setAd($this);
        }
        return $this;
    }
    public function removeBooking(Booking $booking): self
    {
        if ($this->bookings->contains($booking)) {
            $this->bookings->removeElement($booking);
            // set the owning side to null (unless already changed)
            if ($booking->getAd() === $this) {
                $booking->setAd(null);
            }
        }
        return $this;
    }
    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }
    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setAd($this);
        }
        return $this;
    }
    public function removeComment(Comment $comment): self
    {
        if ($this->comments->contains($comment)) {
            $this->comments->removeElement($comment);
            // set the owning side to null (unless already changed)
            if ($comment->getAd() === $this) {
                $comment->setAd(null);
            }
        }
        return $this;
    }
    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->createdAt;
    }
    public function setCreatedAt(?\DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;
        return $this;
    }

    public function getAddress(): AnnounceAddress
    {
        return $this->address;
    }

    public function setAddress(AnnounceAddress $address): self
    {
        $this->address = $address;

        return $this;
    }
}

symfony/src/Entity/User.php
<?php

namespace App\Entity;

use Cocur\Slugify\Slugify;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;

/**
 * @ORM\Entity(repositoryClass="App\Repository\UserRepository")
 * @ORM\HasLifecycleCallbacks()
 * @UniqueEntity(
 *  fields={"email"},
 *  message="Cette email est deja utilisée"
 * )
 */
class User implements UserInterface
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank()
     */
    private $firstName;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank()
     */
    private $lastName;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Email(message="Veuillez renseigner un email valide !")
     */
    private $email;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @Assert\Url(message="Veuillez renseigner une URL valide")
     */
    private $picture;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $hash;

    /**
     * @Assert\EqualTo(propertyPath="hash", message="le mot de passe n'est pas confirmer !")
     */
    public $passwordConfirm;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Length(min=10, minMessage="Votre présentation doit faire au moins 10 caracteres")
     */
    private $presentation;

    /**
     * @ORM\Column(type="text")
     * @Assert\Length(min=100, minMessage="Votre présentation doit faire au moins 100 caracteres")
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $slug;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Ad", mappedBy="author")
     */
    private $ads;

    /**
     * @ORM\ManyToMany(targetEntity="App\Entity\Role", mappedBy="users")
     */
    private $userRoles;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Booking", mappedBy="booker")
     */
    private $bookings;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Comment", mappedBy="author", orphanRemoval=true)
     */
    private $comments;

    public function getFullName(){
        $this->firstName = ucfirst($this->firstName);
        $this->lastName = ucfirst($this->lastName);
        return "{$this->firstName} {$this->lastName}";
    }

    /**
     * Permet d'initialiser le slug
     * 
     * @ORM\PrePersist
     * @ORM\PreUpdate
     *
     * @return void
     */
    public function initializeSlug(){
        if(empty($this->slug)){
            $slugify = new Slugify();
            $this->slug = $slugify->Slugify($this->firstName . ' ' . $this->lastName);
        }
    }

    public function __construct()
    {
        $this->ads = new ArrayCollection();
        $this->userRoles = new ArrayCollection();
        $this->bookings = new ArrayCollection();
        $this->comments = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFirstName(): ?string
    {
        return $this->firstName;
    }

    public function setFirstName(string $firstName): self
    {
        $this->firstName = $firstName;

        return $this;
    }

    public function getLastName(): ?string
    {
        return $this->lastName;
    }

    public function setLastName(string $lastName): self
    {
        $this->lastName = $lastName;

        return $this;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    public function getPicture(): ?string
    {
        return $this->picture;
    }

    public function setPicture(?string $picture): self
    {
        $this->picture = $picture;

        return $this;
    }

    public function getHash(): ?string
    {
        return $this->hash;
    }

    public function setHash(string $hash): self
    {
        $this->hash = $hash;

        return $this;
    }

    public function getPresentation(): ?string
    {
        return $this->presentation;
    }

    public function setPresentation(string $presentation): self
    {
        $this->presentation = $presentation;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    /**
     * @return Collection|Ad[]
     */
    public function getAds(): Collection
    {
        return $this->ads;
    }

    public function addAd(Ad $ad): self
    {
        if (!$this->ads->contains($ad)) {
            $this->ads[] = $ad;
            $ad->setAuthor($this);
        }

        return $this;
    }

    public function removeAd(Ad $ad): self
    {
        if ($this->ads->contains($ad)) {
            $this->ads->removeElement($ad);
            // set the owning side to null (unless already changed)
            if ($ad->getAuthor() === $this) {
                $ad->setAuthor(null);
            }
        }

        return $this;
    }

    public function getRoles()
    {
       
        $roles = $this->userRoles->map(function($role){
            return $role->getTitle();
        })->toArray();

        $roles[] = 'ROLE_USER';

        return $roles;
    }

    public function getPassword()
    {
        return $this->hash;
    }
    public function getSalt() {}

    public function getUsername()
    {
        return $this->email;
    }
    public function eraseCredentials() {}

    /**
     * @return Collection|Role[]
     */
    public function getUserRoles(): Collection
    {
        return $this->userRoles;
    }

    public function addUserRole(Role $userRole): self
    {
        if (!$this->userRoles->contains($userRole)) {
            $this->userRoles[] = $userRole;
            $userRole->addUser($this);
        }

        return $this;
    }

    public function removeUserRole(Role $userRole): self
    {
        if ($this->userRoles->contains($userRole)) {
            $this->userRoles->removeElement($userRole);
            $userRole->removeUser($this);
        }

        return $this;
    }

    /**
     * @return Collection|Booking[]
     */
    public function getBookings(): Collection
    {
        return $this->bookings;
    }

    public function addBooking(Booking $booking): self
    {
        if (!$this->bookings->contains($booking)) {
            $this->bookings[] = $booking;
            $booking->setBooker($this);
        }

        return $this;
    }

    public function removeBooking(Booking $booking): self
    {
        if ($this->bookings->contains($booking)) {
            $this->bookings->removeElement($booking);
            // set the owning side to null (unless already changed)
            if ($booking->getBooker() === $this) {
                $booking->setBooker(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }

    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setAuthor($this);
        }

        return $this;
    }

    public function removeComment(Comment $comment): self
    {
        if ($this->comments->contains($comment)) {
            $this->comments->removeElement($comment);
            // set the owning side to null (unless already changed)
            if ($comment->getAuthor() === $this) {
                $comment->setAuthor(null);
            }
        }

        return $this;
    }
}

symfony/templates/ad/_ad.html.twig
{% set url = path('ads_show', {'slug':ad.slug}) %}

                <div class="col-md-4">
                    <div class="card bg-light mb-3">
                        <div class="card-header text-center">
                            {{ ad.rooms }} chambres, <strong>{{ad.price | number_format(2, ',', ' ')}} € / nuit</strong> <br>

                            {% if ad.comments|length > 0 %}
                                {% include 'shared/rating.html.twig' with {'rating': ad.avgRatings} %}
                            {% else %}
                                <small>Pas encore noté</small>
                            {% endif %}<br>
                            {{ ad.address.city }}
                        </div>

                        <a href="{{ url }}">
                            <img src={{ad.coverImage}} class="principalimage" alt="Image de l'appartement"
                            style="height: 200px; width: 100%; display: block">
                        </a>

                        <div class="card-body">
                            <h4 class="card-title">
                                <a href="{{ url }}" class="card-title-link">
                                    <span>{{ad.title|truncate(15)}}</span>
                                    <span>{{ad.author.firstname}} vous souhaite la bienvenue</span>
                                </a>
                                <hr>
                            </h4>
                            <p class="card-text">{{ad.introduction|truncate(65)}}</p>
                            <a href="{{ url }}" class="btn btn-primary float-right">En savoir plus !</a>
                             {% if app.user and app.user == ad.author %}
                                <a href="{{ path('ads_edit', {'slug': ad.slug}) }}" class="btn btn-secondary">Modifier l'annonce</a>
                            {% endif %}
                        </div>
                    </div>
                </div>

symfony/templates/ad/_collection.html.twig
{% block _ad_images_widget %}
    <p>Ici, vous pouvez ajouter vos propres images !</p>

    {{ form_widget(form) }}

    <input type="hidden" id="widgets-counter" value="0">

    <div class="form-group">
        <button type="button" id="add-image" class="btn btn-primary">
            <i class="fas fa-images"></i>
            Ajouter une image
        </button>
    </div>
{% endblock %}

{% block _ad_images_entry_row %}
    {{ form_widget(form) }}
{% endblock %}

{% block _ad_images_entry_widget %}
    <div class="form-group" id="block_{{id}}">
    {{ form_errors(form) }}
        <div class="row">
            <div class="col-10">
                <div class="row">
                    <div class="col">
                        {{ form_widget(form.url) }}
                        {{ form_errors(form.url) }}
                    </div>
                    <div class="col">
                        {{ form_widget(form.caption) }}
                        {{ form_errors(form.caption) }}
                    </div>
                </div>
            </div>
            <div class="col-2">
                <button type="button" data-action="delete" data-target="#block_{{id}}" class="btn btn-danger">X</button>
            </div>
        </div>
    </div>
{% endblock %}

symfony/templates/ad/edit.html.twig
{% extends "base.html.twig" %}

{% block title %}Edition d'une annonce{% endblock %}

{% form_theme form 'ad/_collection.html.twig' %}

{% block body %}

 <div class="container">
        <h1>Modification de l'annonce : {{ ad.title }}</h1>

       {{form_start(form)}}
      
            {{form_widget(form)}}

       <button type="submit" class="btn btn-primary">Enregistrer les modifications</button>

       {{form_end(form)}}

    </div>

{% endblock %}

{% block javascripts %}
    <script src="{{ asset('build/js/add.js')}}"></script>
{% endblock %}

symfony/templates/ad/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Nos magnifiques annonces{% endblock %}

{% block body %}
<div class="container">
    <h1 class="my-5">Voici les annones de nos hôtes !</h1>

    <div class="row">
        {% for ad in ads %}
           {% include "ad/_ad.html.twig" %}
        {% endfor %}
    </div>
</div>
    
{% endblock %}

symfony/templates/ad/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}Création d'une annonece{% endblock %}

{% form_theme form 'ad/_collection.html.twig' %}

{% block body %}

    <div class="container">
        <h1 class="my-5">Créer une nouvelle annonce</h1>

        {{ form_start(form) }}

        <div class="row">
            <div class="col">
                <div class="alert alert-light">
                    <h2>Informations générales</h2>
                    <hr>
                    {{ form_row(form.title) }}
                    {{ form_row(form.slug) }}
                    {{ form_row(form.price) }}
                    {{ form_row(form.rooms) }}
                </div>
                <div class="alert alert-light">
                    <h2>Détails de l'annonce</h2>
                    <hr>
                    {{ form_row(form.introduction) }}
                    {{ form_row(form.content) }}
                </div>
            </div>
            <div class="col">
                <div class="alert alert-light">
                    <h2>Images de l'annonce</h2>
                    <hr>
                    {{ form_row(form.coverImage) }}
                    {{ form_row(form.images) }}
                </div>
                <div class="alert alert-light">
                    <h2>Adresse de l'annonce</h2>
                    <hr>
                    {{ form_row(form.address) }}
                </div>
            </div>
        </div>

        <div class="alert alert-success clearfix">
            <h2 class="alert-heading">Sauvegarder mon annonce</h2>
            <p>Vous êtes sur le point de créer votre annonce, Je suis super fier de vous !</p>
            <button type="submit" class="btn btn-primary float-right animate-magic" data-animation="magic">
                <i class="fas fa-check"></i>
                Créer la nouvelle annonce
            </button>
        </div>

        {{ form_end(form) }}
    </div>

{% endblock %}

{% block javascripts %}

<script src="{{ asset('build/js/add.js') }}"></script>
<script src="{{ asset('build/js/animate-magic.js') }}"></script>

{% endblock %}

symfony/templates/ad/show.html.twig
{% extends "base.html.twig" %}

{% block title %}
    {{ad.title}}
{% endblock %}

{% block body %}

<div class="ad-title" style="background-image: url({{ ad.coverImage }})">
    <div class="container">
        <h1>{{ad.title}}</h1>
        <p>{{ad.introduction | raw}}</p>
        <p>{{ ad.address.address }}</p>
        <p>{{ ad.address.postCode }}</p>
        <p>{{ ad.address.city }}</p>
        <p class="h2">
            <strong>{{ad.rooms}}
            chambres</strong>
             pour<strong>{{ad.price | number_format(2, ',', ' ')}}
                €</strong>
             / nuit</p>
        <a href="{{ path('booking_create', {'slug': ad.slug})}}" class="btn btn-primary">Réservé</a>
        {% if app.user and app.user == ad.author %}
            <a href="{{ path('ads_edit', {'slug': ad.slug}) }}" class="btn btn-secondary">Modifier l'annonce</a>
            <a href="{{ path('ads_delete', {'slug': ad.slug}) }}" class="btn btn-danger" 
            onclick="return confirm(`Etes-vous sur de vouloir supprimer l'annonce : {{ ad.title }} ?`)">Supprimer l'annonce</a>
        {% endif %}
    </div>
</div>


<div class="container">
    <div class="row">
        <div class="col-md-8 mb-3">
            {{ad.content | raw}}
            <hr>

            {# Debut du carrousel #}
             <div id="carouselExampleCaptions" class="slick slider">
                {% for image in ad.images %}
                <div class="slick-item">
                    <img src="{{image.url}}" class="d-block w-100" alt="">
                    <div class="item-caption d-none d-md-block">
                        <h5>{{image.caption}}</h5>
                    </div>
                </div>
                {% endfor %}
            </div>
            <hr>

            {% if ad.comments | length > 0 %}

            <h2 class="mb-3">Commentaires de nos voyageurs :</h2>

            <div class="alert alert-info">
                <h4 class="alert-heading text-center">
                    <div class="row align-items-center">
                        <div class="col">
                            Note globale données par nos voyageurs
                        </div>
                        <div class="col">
                            {% include "shared/rating.html.twig" with {'rating': ad.avgRatings} %}<br>
                            <small>(Claculée sur {{ad.comments | length}} avis)</small>
                        </div>
                    </div>
                </h4>
            </div>

            {% for comment in ad.comments %}
                <div class="bg-light rounded mb-3 py-3 px-3">
                    <strong>{{comment.author.fullName}}</strong> a dit :
                    <blockquote>
                        {{comment.content}}
                    </blockquote>
                    <strong>Note donnée:</strong>
                   {% include "shared/rating.html.twig" with {'rating' : comment.rating} %}
                </div>
            {% endfor %}

            {% else %}
                <h2>cette annonce n'as pas encore reçu de commentaire ...</h2>
            
            {% endif %}
            

        </div>

            {# Debut présentation hebergeur #}
        
        <div class="col">
        {% set a = ad.author %}
            <div class="row">
                <div class="col_2">
                <a href="{{ path('user_show', {'slug': a.slug}) }}">
                    <img src="{{ a.picture }}" class="avatar avatar-medium" alt="Avatar de {{ a.fullName }}">
                </a>
                </div>
                <div class="col">
                    <a href="{{ path('user_show', {'slug': a.slug}) }}">
                        <h3>{{ a.fullName }}</h3>
                    </a>
                    <span class="badge badge-primary">{{a.ads | length}} 
                    {% if a.ads | length > 1 %}
                     annonces
                    {% else %}
                     annonce
                    {% endif %}
                    </span>                
                </div>
            </div>
               {{a.description | raw}}
                <div id="mapid"></div>
            </div>
        </div>
    </div>  

{% endblock %}
{% block javascripts %}
    <script>
    var mymap = L.map('mapid').setView([{{ad.address.lat}}, {{ad.address.longi}}], 18);
    var marker = L.marker([{{ad.address.lat}}, {{ad.address.longi}}]).addTo(mymap);
    L.tileLayer('https://api.mapbox.com/styles/v1/{id}/tiles/{z}/{x}/{y}?access_token={accessToken}', {
        attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
        maxZoom: 18,
        id: 'mapbox/streets-v11',
        accessToken: 'pk.eyJ1Ijoia2FsaWxpbnV4NjkiLCJhIjoiY2s0aWZkZW9xMWtmNzNmbWdmdzN0M2V1YSJ9.x_7zrgJ4DrIsopADQrq5Sg'
    }).addTo(mymap);
    </script>
{% endblock %}